package DX::Result;

use Moo;

has _state => (is => 'ro', required => 1, init_arg => 'state');

sub var_names {
  sort keys %{$_[0]->_state->scope};
}

sub actions {
  my ($self) = @_;
  my $by_id = $self->_state->by_id;
  return map $_->action, grep $_->has_action, values %$by_id;
}

sub independent_actions {
  my ($self) = @_;
  return grep !@{$_->dependencies}, $self->actions;
}

sub expand_action_dependencies {
  my ($self, $action) = @_;
  my $by_id = $self->_state->by_id;
  return map $by_id->{$_}->action, @{$action->dependencies};
}

sub value_for {
  my ($self, $name) = @_;
  $self->_state->scope_var($name)->bound_value;
}

1;
